PingOne Platform APIs

Update promotion

PATCH {{apiPath}}/v1/environments/{{envID}}/promotions/{{promotionID}}

Use the PATCH {{apiPath}}/v1/environments/{{envID}}/promotions/{{promotionID}} request to update the promotion details for the specified promotion. The request body can contain only description, resourceMapping, selectedResources, and excludedResources. The target environment cannot be changed, so is not needed in the request body.

Request Model

For complete property descriptions, refer to Promotions.

Property Type Required

description

String

Optional

excludedResources

Object[]*

Optional

resourceMapping

Map

Optional

selectedResources

Object[]*

Optional

sourceEnvironment

Object

Optional

targetEnvironment

Object

Required

sourceSnapshot

Object

Optional

Headers

Authorization      Bearer {{accessToken}}

Content-Type      application/json

Body

raw ( application/json )

{
  "excludedResources": [
    "6b475594-2c28-4627-acf5-e196fdc4d2eb"
  ],
  "description": "Updated promotion description"
}

Example Request

  • cURL

  • C#

  • Go

  • HTTP

  • Java

  • jQuery

  • NodeJS

  • Python

  • PHP

  • Ruby

  • Swift

curl --location --globoff --request PATCH '{{apiPath}}/v1/environments/{{envID}}/promotions/{{promotionID}}' \
--header 'Content-Type: application/json' \
--header 'Authorization: Bearer {{accessToken}}' \
--data '{
  "excludedResources": [
    "6b475594-2c28-4627-acf5-e196fdc4d2eb"
  ],
  "description": "Updated promotion description"
}'
var options = new RestClientOptions("{{apiPath}}/v1/environments/{{envID}}/promotions/{{promotionID}}")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Patch);
request.AddHeader("Content-Type", "application/json");
request.AddHeader("Authorization", "Bearer {{accessToken}}");
var body = @"{" + "\n" +
@"  ""excludedResources"": [" + "\n" +
@"    ""6b475594-2c28-4627-acf5-e196fdc4d2eb""" + "\n" +
@"  ]," + "\n" +
@"  ""description"": ""Updated promotion description""" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/v1/environments/{{envID}}/promotions/{{promotionID}}"
  method := "PATCH"

  payload := strings.NewReader(`{
  "excludedResources": [
    "6b475594-2c28-4627-acf5-e196fdc4d2eb"
  ],
  "description": "Updated promotion description"
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Content-Type", "application/json")
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
PATCH /v1/environments/{{envID}}/promotions/{{promotionID}} HTTP/1.1
Host: {{apiPath}}
Content-Type: application/json
Authorization: Bearer {{accessToken}}

{
  "excludedResources": [
    "6b475594-2c28-4627-acf5-e196fdc4d2eb"
  ],
  "description": "Updated promotion description"
}
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "{\n  \"excludedResources\": [\n    \"6b475594-2c28-4627-acf5-e196fdc4d2eb\"\n  ],\n  \"description\": \"Updated promotion description\"\n}");
Request request = new Request.Builder()
  .url("{{apiPath}}/v1/environments/{{envID}}/promotions/{{promotionID}}")
  .method("PATCH", body)
  .addHeader("Content-Type", "application/json")
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
var settings = {
  "url": "{{apiPath}}/v1/environments/{{envID}}/promotions/{{promotionID}}",
  "method": "PATCH",
  "timeout": 0,
  "headers": {
    "Content-Type": "application/json",
    "Authorization": "Bearer {{accessToken}}"
  },
  "data": JSON.stringify({
    "excludedResources": [
      "6b475594-2c28-4627-acf5-e196fdc4d2eb"
    ],
    "description": "Updated promotion description"
  }),
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
var request = require('request');
var options = {
  'method': 'PATCH',
  'url': '{{apiPath}}/v1/environments/{{envID}}/promotions/{{promotionID}}',
  'headers': {
    'Content-Type': 'application/json',
    'Authorization': 'Bearer {{accessToken}}'
  },
  body: JSON.stringify({
    "excludedResources": [
      "6b475594-2c28-4627-acf5-e196fdc4d2eb"
    ],
    "description": "Updated promotion description"
  })

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
import requests
import json

url = "{{apiPath}}/v1/environments/{{envID}}/promotions/{{promotionID}}"

payload = json.dumps({
  "excludedResources": [
    "6b475594-2c28-4627-acf5-e196fdc4d2eb"
  ],
  "description": "Updated promotion description"
})
headers = {
  'Content-Type': 'application/json',
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("PATCH", url, headers=headers, data=payload)

print(response.text)
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/v1/environments/{{envID}}/promotions/{{promotionID}}');
$request->setMethod('PATCH');
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Content-Type' => 'application/json',
  'Authorization' => 'Bearer {{accessToken}}'
));
$request->setBody('{\n  "excludedResources": [\n    "6b475594-2c28-4627-acf5-e196fdc4d2eb"\n  ],\n  "description": "Updated promotion description"\n}');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
require "uri"
require "json"
require "net/http"

url = URI("{{apiPath}}/v1/environments/{{envID}}/promotions/{{promotionID}}")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Patch.new(url)
request["Content-Type"] = "application/json"
request["Authorization"] = "Bearer {{accessToken}}"
request.body = JSON.dump({
  "excludedResources": [
    "6b475594-2c28-4627-acf5-e196fdc4d2eb"
  ],
  "description": "Updated promotion description"
})

response = http.request(request)
puts response.read_body
let parameters = "{\n  \"excludedResources\": [\n    \"6b475594-2c28-4627-acf5-e196fdc4d2eb\"\n  ],\n  \"description\": \"Updated promotion description\"\n}"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{apiPath}}/v1/environments/{{envID}}/promotions/{{promotionID}}")!,timeoutInterval: Double.infinity)
request.addValue("application/json", forHTTPHeaderField: "Content-Type")
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "PATCH"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()

Example Response

200 OK

{
    "_links": {
        "self": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/promotions/1d0ff9f4-0fae-4859-9dfa-0aa6cac9150e"
        },
        "environment": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
        },
        "targetEnvironment": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
        },
        "sourceSnapshot": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/snapshots/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/versions/cc64ea07-1da0-4bf8-b487-5c178667d8c8"
        },
        "targetSnapshot": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/snapshots/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/versions/77a10527-328a-432c-b04a-9530d3232164"
        },
        "promotionSteps": {
          "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/promotions/58b5aeab-643c-4e5f-bd7c-463fd6cd66be/promotionSteps"
        }
    },
    "id": "1d0ff9f4-0fae-4859-9dfa-0aa6cac9150e",
    "createdAt": "2024-09-06T14:24:53.970Z",
    "updatedAt": "2024-09-11T14:44:28.760Z",
    "sourceEnvironment": {
        "id": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
    },
    "targetEnvironment": {
        "id": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
    },
    "sourceSnapshot": {
        "id": "efb68607-1220-4893-8986-b8e1675f5309"
    },
    "targetSnapshot": {
        "id": "5205a4af-4751-4778-9985-00651ef93815"
    },
    "status": "PREPARING",
    "selectedResources": [
        "0b7795ac-c589-4311-82bd-b1a9caff7a6a"
    ],
      "excludedResources": [
    "6b475594-2c28-4627-acf5-e196fdc4d2eb"
  ],
  "description": "Updated promotion description"
}